#include "OS_Process.h"
#include "Prefix.h"
#include <Windows.h>

namespace EARTH {
namespace OS {

bool Process::IsWow64()
{
	bool b = false;

	HMODULE module = ::LoadLibrary(TEXT("Kernel32.dll"));
	if (module == NULL) return b;

	BOOL (WINAPI *function)(HANDLE, PBOOL);

	function = reinterpret_cast<BOOL (WINAPI *)(HANDLE, PBOOL)>(::GetProcAddress(module, "IsWow64Process"));
	if (function) {
		BOOL result;
		BOOL wow64process;
		result = function(::GetCurrentProcess(), &wow64process);
		if (result && wow64process) {
			b = true;
		}
	}

	::FreeLibrary(module);
	module = NULL;

	return b;
}

}
}
